import ve, { useState as O, createContext as Le, useMemo as P, useCallback as T, useEffect as D, useContext as Ce } from "react";
import { useQueryClient as Je, useQuery as se } from "@tanstack/react-query";
import { gql as _, GraphQLClient as Me } from "graphql-request";
import { useAccount as ke, useChainId as Ne, useSignMessage as ze } from "wagmi";
import { GraphQLError as K } from "graphql";
new TextEncoder();
const pe = new TextDecoder(), We = (e) => {
  const t = atob(e), n = new Uint8Array(t.length);
  for (let r = 0; r < t.length; r++)
    n[r] = t.charCodeAt(r);
  return n;
}, Pe = (e) => {
  let t = e;
  t instanceof Uint8Array && (t = pe.decode(t)), t = t.replace(/-/g, "+").replace(/_/g, "/").replace(/\s/g, "");
  try {
    return We(t);
  } catch {
    throw new TypeError("The input to be decoded is not correctly encoded.");
  }
};
class p extends Error {
  constructor(t, n) {
    var r;
    super(t, n), this.code = "ERR_JOSE_GENERIC", this.name = this.constructor.name, (r = Error.captureStackTrace) == null || r.call(Error, this, this.constructor);
  }
}
p.code = "ERR_JOSE_GENERIC";
class De extends p {
  constructor(t, n, r = "unspecified", s = "unspecified") {
    super(t, { cause: { claim: r, reason: s, payload: n } }), this.code = "ERR_JWT_CLAIM_VALIDATION_FAILED", this.claim = r, this.reason = s, this.payload = n;
  }
}
De.code = "ERR_JWT_CLAIM_VALIDATION_FAILED";
class Fe extends p {
  constructor(t, n, r = "unspecified", s = "unspecified") {
    super(t, { cause: { claim: r, reason: s, payload: n } }), this.code = "ERR_JWT_EXPIRED", this.claim = r, this.reason = s, this.payload = n;
  }
}
Fe.code = "ERR_JWT_EXPIRED";
class Be extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JOSE_ALG_NOT_ALLOWED";
  }
}
Be.code = "ERR_JOSE_ALG_NOT_ALLOWED";
class Ve extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JOSE_NOT_SUPPORTED";
  }
}
Ve.code = "ERR_JOSE_NOT_SUPPORTED";
class Ke extends p {
  constructor(t = "decryption operation failed", n) {
    super(t, n), this.code = "ERR_JWE_DECRYPTION_FAILED";
  }
}
Ke.code = "ERR_JWE_DECRYPTION_FAILED";
class qe extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JWE_INVALID";
  }
}
qe.code = "ERR_JWE_INVALID";
class He extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JWS_INVALID";
  }
}
He.code = "ERR_JWS_INVALID";
class $ extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JWT_INVALID";
  }
}
$.code = "ERR_JWT_INVALID";
class je extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JWK_INVALID";
  }
}
je.code = "ERR_JWK_INVALID";
class Ge extends p {
  constructor() {
    super(...arguments), this.code = "ERR_JWKS_INVALID";
  }
}
Ge.code = "ERR_JWKS_INVALID";
class Xe extends p {
  constructor(t = "no applicable key found in the JSON Web Key Set", n) {
    super(t, n), this.code = "ERR_JWKS_NO_MATCHING_KEY";
  }
}
Xe.code = "ERR_JWKS_NO_MATCHING_KEY";
class Ze extends p {
  constructor(t = "multiple matching keys found in the JSON Web Key Set", n) {
    super(t, n), this.code = "ERR_JWKS_MULTIPLE_MATCHING_KEYS";
  }
}
Ze.code = "ERR_JWKS_MULTIPLE_MATCHING_KEYS";
class Ye extends p {
  constructor(t = "request timed out", n) {
    super(t, n), this.code = "ERR_JWKS_TIMEOUT";
  }
}
Ye.code = "ERR_JWKS_TIMEOUT";
class Qe extends p {
  constructor(t = "signature verification failed", n) {
    super(t, n), this.code = "ERR_JWS_SIGNATURE_VERIFICATION_FAILED";
  }
}
Qe.code = "ERR_JWS_SIGNATURE_VERIFICATION_FAILED";
function et(e) {
  return typeof e == "object" && e !== null;
}
function tt(e) {
  if (!et(e) || Object.prototype.toString.call(e) !== "[object Object]")
    return !1;
  if (Object.getPrototypeOf(e) === null)
    return !0;
  let t = e;
  for (; Object.getPrototypeOf(t) !== null; )
    t = Object.getPrototypeOf(t);
  return Object.getPrototypeOf(e) === t;
}
const nt = Pe;
function oe(e) {
  if (typeof e != "string")
    throw new $("JWTs must use Compact JWS serialization, JWT must be a string");
  const { 1: t, length: n } = e.split(".");
  if (n === 5)
    throw new $("Only JWTs using Compact JWS serialization can be decoded");
  if (n !== 3)
    throw new $("Invalid JWT");
  if (!t)
    throw new $("JWTs must contain a payload");
  let r;
  try {
    r = nt(t);
  } catch {
    throw new $("Failed to base64url decode the payload");
  }
  let s;
  try {
    s = JSON.parse(pe.decode(r));
  } catch {
    throw new $("Failed to parse the decoded payload as JSON");
  }
  if (!tt(s))
    throw new $("Invalid JWT Claims Set");
  return s;
}
const rt = _`
  mutation Login($message: String!, $signature: String!) {
    login(message: $message, signature: $signature)
  }
`;
async function st(e, t) {
  const n = {
    message: t.message,
    signature: t.signature
  };
  return e.request(rt, n).then(async (r) => r.login.accessToken).catch((r) => {
    var o, i;
    console.log("Authorization error:", { errors: r });
    const s = Array.isArray((o = r == null ? void 0 : r.response) == null ? void 0 : o.errors) ? (i = r.response.errors[0]) == null ? void 0 : i.message : "Unknown error";
    throw new Error(s);
  });
}
const ot = _`
  mutation GetNonce($address: Address!) {
    nonce(address: $address)
  }
`;
async function it(e, t) {
  const n = {
    address: t
  };
  return e.request(ot, n).then((r) => r.nonce).catch((r) => {
    var o, i;
    console.log("Error fetching nonce for address:", t, { errors: r });
    const s = Array.isArray((o = r == null ? void 0 : r.response) == null ? void 0 : o.errors) ? (i = r.response.errors[0]) == null ? void 0 : i.message : "Error fetching nonce";
    throw Error(s);
  });
}
function ie(e) {
  if (!Number.isSafeInteger(e) || e < 0)
    throw new Error(`positive integer expected, not ${e}`);
}
function ct(e) {
  return e instanceof Uint8Array || e != null && typeof e == "object" && e.constructor.name === "Uint8Array";
}
function q(e, ...t) {
  if (!ct(e))
    throw new Error("Uint8Array expected");
  if (t.length > 0 && !t.includes(e.length))
    throw new Error(`Uint8Array expected of length ${t}, not of length=${e.length}`);
}
function ce(e, t = !0) {
  if (e.destroyed)
    throw new Error("Hash instance has been destroyed");
  if (t && e.finished)
    throw new Error("Hash#digest() has already been called");
}
function at(e, t) {
  q(e);
  const n = t.outputLen;
  if (e.length < n)
    throw new Error(`digestInto() expects output buffer of length at least ${n}`);
}
const N = /* @__PURE__ */ BigInt(2 ** 32 - 1), ae = /* @__PURE__ */ BigInt(32);
function ut(e, t = !1) {
  return t ? { h: Number(e & N), l: Number(e >> ae & N) } : { h: Number(e >> ae & N) | 0, l: Number(e & N) | 0 };
}
function lt(e, t = !1) {
  let n = new Uint32Array(e.length), r = new Uint32Array(e.length);
  for (let s = 0; s < e.length; s++) {
    const { h: o, l: i } = ut(e[s], t);
    [n[s], r[s]] = [o, i];
  }
  return [n, r];
}
const ft = (e, t, n) => e << n | t >>> 32 - n, dt = (e, t, n) => t << n | e >>> 32 - n, ht = (e, t, n) => t << n - 32 | e >>> 64 - n, gt = (e, t, n) => e << n - 32 | t >>> 64 - n;
/*! noble-hashes - MIT License (c) 2022 Paul Miller (paulmillr.com) */
const mt = (e) => new Uint32Array(e.buffer, e.byteOffset, Math.floor(e.byteLength / 4)), ue = new Uint8Array(new Uint32Array([287454020]).buffer)[0] === 68, pt = (e) => e << 24 & 4278190080 | e << 8 & 16711680 | e >>> 8 & 65280 | e >>> 24 & 255;
function le(e) {
  for (let t = 0; t < e.length; t++)
    e[t] = pt(e[t]);
}
function wt(e) {
  if (typeof e != "string")
    throw new Error(`utf8ToBytes expected string, got ${typeof e}`);
  return new Uint8Array(new TextEncoder().encode(e));
}
function we(e) {
  return typeof e == "string" && (e = wt(e)), q(e), e;
}
class Et {
  // Safe version that clones internal state
  clone() {
    return this._cloneInto();
  }
}
function yt(e) {
  const t = (r) => e().update(we(r)).digest(), n = e();
  return t.outputLen = n.outputLen, t.blockLen = n.blockLen, t.create = () => e(), t;
}
const Ee = [], ye = [], Ie = [], It = /* @__PURE__ */ BigInt(0), J = /* @__PURE__ */ BigInt(1), bt = /* @__PURE__ */ BigInt(2), At = /* @__PURE__ */ BigInt(7), St = /* @__PURE__ */ BigInt(256), xt = /* @__PURE__ */ BigInt(113);
for (let e = 0, t = J, n = 1, r = 0; e < 24; e++) {
  [n, r] = [r, (2 * n + 3 * r) % 5], Ee.push(2 * (5 * r + n)), ye.push((e + 1) * (e + 2) / 2 % 64);
  let s = It;
  for (let o = 0; o < 7; o++)
    t = (t << J ^ (t >> At) * xt) % St, t & bt && (s ^= J << (J << /* @__PURE__ */ BigInt(o)) - J);
  Ie.push(s);
}
const [$t, _t] = /* @__PURE__ */ lt(Ie, !0), fe = (e, t, n) => n > 32 ? ht(e, t, n) : ft(e, t, n), de = (e, t, n) => n > 32 ? gt(e, t, n) : dt(e, t, n);
function Rt(e, t = 24) {
  const n = new Uint32Array(10);
  for (let r = 24 - t; r < 24; r++) {
    for (let i = 0; i < 10; i++)
      n[i] = e[i] ^ e[i + 10] ^ e[i + 20] ^ e[i + 30] ^ e[i + 40];
    for (let i = 0; i < 10; i += 2) {
      const c = (i + 8) % 10, l = (i + 2) % 10, h = n[l], g = n[l + 1], A = fe(h, g, 1) ^ n[c], S = de(h, g, 1) ^ n[c + 1];
      for (let f = 0; f < 50; f += 10)
        e[i + f] ^= A, e[i + f + 1] ^= S;
    }
    let s = e[2], o = e[3];
    for (let i = 0; i < 24; i++) {
      const c = ye[i], l = fe(s, o, c), h = de(s, o, c), g = Ee[i];
      s = e[g], o = e[g + 1], e[g] = l, e[g + 1] = h;
    }
    for (let i = 0; i < 50; i += 10) {
      for (let c = 0; c < 10; c++)
        n[c] = e[i + c];
      for (let c = 0; c < 10; c++)
        e[i + c] ^= ~n[(c + 2) % 10] & n[(c + 4) % 10];
    }
    e[0] ^= $t[r], e[1] ^= _t[r];
  }
  n.fill(0);
}
class H extends Et {
  // NOTE: we accept arguments in bytes instead of bits here.
  constructor(t, n, r, s = !1, o = 24) {
    if (super(), this.blockLen = t, this.suffix = n, this.outputLen = r, this.enableXOF = s, this.rounds = o, this.pos = 0, this.posOut = 0, this.finished = !1, this.destroyed = !1, ie(r), 0 >= this.blockLen || this.blockLen >= 200)
      throw new Error("Sha3 supports only keccak-f1600 function");
    this.state = new Uint8Array(200), this.state32 = mt(this.state);
  }
  keccak() {
    ue || le(this.state32), Rt(this.state32, this.rounds), ue || le(this.state32), this.posOut = 0, this.pos = 0;
  }
  update(t) {
    ce(this);
    const { blockLen: n, state: r } = this;
    t = we(t);
    const s = t.length;
    for (let o = 0; o < s; ) {
      const i = Math.min(n - this.pos, s - o);
      for (let c = 0; c < i; c++)
        r[this.pos++] ^= t[o++];
      this.pos === n && this.keccak();
    }
    return this;
  }
  finish() {
    if (this.finished)
      return;
    this.finished = !0;
    const { state: t, suffix: n, pos: r, blockLen: s } = this;
    t[r] ^= n, n & 128 && r === s - 1 && this.keccak(), t[s - 1] ^= 128, this.keccak();
  }
  writeInto(t) {
    ce(this, !1), q(t), this.finish();
    const n = this.state, { blockLen: r } = this;
    for (let s = 0, o = t.length; s < o; ) {
      this.posOut >= r && this.keccak();
      const i = Math.min(r - this.posOut, o - s);
      t.set(n.subarray(this.posOut, this.posOut + i), s), this.posOut += i, s += i;
    }
    return t;
  }
  xofInto(t) {
    if (!this.enableXOF)
      throw new Error("XOF is not possible for this instance");
    return this.writeInto(t);
  }
  xof(t) {
    return ie(t), this.xofInto(new Uint8Array(t));
  }
  digestInto(t) {
    if (at(t, this), this.finished)
      throw new Error("digest() was already called");
    return this.writeInto(t), this.destroy(), t;
  }
  digest() {
    return this.digestInto(new Uint8Array(this.outputLen));
  }
  destroy() {
    this.destroyed = !0, this.state.fill(0);
  }
  _cloneInto(t) {
    const { blockLen: n, suffix: r, outputLen: s, rounds: o, enableXOF: i } = this;
    return t || (t = new H(n, r, s, i, o)), t.state32.set(this.state32), t.pos = this.pos, t.posOut = this.posOut, t.finished = this.finished, t.rounds = o, t.suffix = r, t.outputLen = s, t.enableXOF = i, t.destroyed = this.destroyed, t;
  }
}
const Tt = (e, t, n) => yt(() => new H(t, e, n)), Ot = /* @__PURE__ */ Tt(1, 136, 256 / 8);
function j(e, { strict: t = !0 } = {}) {
  return !e || typeof e != "string" ? !1 : t ? /^0x[0-9a-fA-F]*$/.test(e) : e.startsWith("0x");
}
const be = "2.21.50";
let M = {
  getDocsUrl: ({ docsBaseUrl: e, docsPath: t = "", docsSlug: n }) => t ? `${e ?? "https://viem.sh"}${t}${n ? `#${n}` : ""}` : void 0,
  version: `viem@${be}`
};
class b extends Error {
  constructor(t, n = {}) {
    var c;
    const r = (() => {
      var l;
      return n.cause instanceof b ? n.cause.details : (l = n.cause) != null && l.message ? n.cause.message : n.details;
    })(), s = n.cause instanceof b && n.cause.docsPath || n.docsPath, o = (c = M.getDocsUrl) == null ? void 0 : c.call(M, { ...n, docsPath: s }), i = [
      t || "An error occurred.",
      "",
      ...n.metaMessages ? [...n.metaMessages, ""] : [],
      ...o ? [`Docs: ${o}`] : [],
      ...r ? [`Details: ${r}`] : [],
      ...M.version ? [`Version: ${M.version}`] : []
    ].join(`
`);
    super(i, n.cause ? { cause: n.cause } : void 0), Object.defineProperty(this, "details", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), Object.defineProperty(this, "docsPath", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), Object.defineProperty(this, "metaMessages", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), Object.defineProperty(this, "shortMessage", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), Object.defineProperty(this, "version", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), Object.defineProperty(this, "name", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: "BaseError"
    }), this.details = r, this.docsPath = s, this.metaMessages = n.metaMessages, this.name = n.name ?? this.name, this.shortMessage = t, this.version = be;
  }
  walk(t) {
    return Ae(this, t);
  }
}
function Ae(e, t) {
  return t != null && t(e) ? e : e && typeof e == "object" && "cause" in e && e.cause !== void 0 ? Ae(e.cause, t) : t ? null : e;
}
class Se extends b {
  constructor({ size: t, targetSize: n, type: r }) {
    super(`${r.charAt(0).toUpperCase()}${r.slice(1).toLowerCase()} size (${t}) exceeds padding size (${n}).`, { name: "SizeExceedsPaddingSizeError" });
  }
}
function z(e, { dir: t, size: n = 32 } = {}) {
  return typeof e == "string" ? Ut(e, { dir: t, size: n }) : vt(e, { dir: t, size: n });
}
function Ut(e, { dir: t, size: n = 32 } = {}) {
  if (n === null)
    return e;
  const r = e.replace("0x", "");
  if (r.length > n * 2)
    throw new Se({
      size: Math.ceil(r.length / 2),
      targetSize: n,
      type: "hex"
    });
  return `0x${r[t === "right" ? "padEnd" : "padStart"](n * 2, "0")}`;
}
function vt(e, { dir: t, size: n = 32 } = {}) {
  if (n === null)
    return e;
  if (e.length > n)
    throw new Se({
      size: e.length,
      targetSize: n,
      type: "bytes"
    });
  const r = new Uint8Array(n);
  for (let s = 0; s < n; s++) {
    const o = t === "right";
    r[o ? s : n - s - 1] = e[o ? s : e.length - s - 1];
  }
  return r;
}
class Lt extends b {
  constructor({ max: t, min: n, signed: r, size: s, value: o }) {
    super(`Number "${o}" is not in safe ${s ? `${s * 8}-bit ${r ? "signed" : "unsigned"} ` : ""}integer range ${t ? `(${n} to ${t})` : `(above ${n})`}`, { name: "IntegerOutOfRangeError" });
  }
}
class Ct extends b {
  constructor({ givenSize: t, maxSize: n }) {
    super(`Size cannot exceed ${n} bytes. Given size: ${t} bytes.`, { name: "SizeOverflowError" });
  }
}
function he(e) {
  return j(e, { strict: !1 }) ? Math.ceil((e.length - 2) / 2) : e.length;
}
function G(e, { size: t }) {
  if (he(e) > t)
    throw new Ct({
      givenSize: he(e),
      maxSize: t
    });
}
function Jt(e, t = {}) {
  const { signed: n, size: r } = t, s = BigInt(e);
  let o;
  r ? n ? o = (1n << BigInt(r) * 8n - 1n) - 1n : o = 2n ** (BigInt(r) * 8n) - 1n : typeof e == "number" && (o = BigInt(Number.MAX_SAFE_INTEGER));
  const i = typeof o == "bigint" && n ? -o - 1n : 0;
  if (o && s > o || s < i) {
    const l = typeof e == "bigint" ? "n" : "";
    throw new Lt({
      max: o ? `${o}${l}` : void 0,
      min: `${i}${l}`,
      signed: n,
      size: r,
      value: `${e}${l}`
    });
  }
  const c = `0x${(n && s < 0 ? (1n << BigInt(r * 8)) + BigInt(s) : s).toString(16)}`;
  return r ? z(c, { size: r }) : c;
}
const Mt = /* @__PURE__ */ new TextEncoder();
function kt(e, t = {}) {
  return typeof e == "number" || typeof e == "bigint" ? zt(e, t) : typeof e == "boolean" ? Nt(e, t) : j(e) ? xe(e, t) : $e(e, t);
}
function Nt(e, t = {}) {
  const n = new Uint8Array(1);
  return n[0] = Number(e), typeof t.size == "number" ? (G(n, { size: t.size }), z(n, { size: t.size })) : n;
}
const I = {
  zero: 48,
  nine: 57,
  A: 65,
  F: 70,
  a: 97,
  f: 102
};
function ge(e) {
  if (e >= I.zero && e <= I.nine)
    return e - I.zero;
  if (e >= I.A && e <= I.F)
    return e - (I.A - 10);
  if (e >= I.a && e <= I.f)
    return e - (I.a - 10);
}
function xe(e, t = {}) {
  let n = e;
  t.size && (G(n, { size: t.size }), n = z(n, { dir: "right", size: t.size }));
  let r = n.slice(2);
  r.length % 2 && (r = `0${r}`);
  const s = r.length / 2, o = new Uint8Array(s);
  for (let i = 0, c = 0; i < s; i++) {
    const l = ge(r.charCodeAt(c++)), h = ge(r.charCodeAt(c++));
    if (l === void 0 || h === void 0)
      throw new b(`Invalid byte sequence ("${r[c - 2]}${r[c - 1]}" in "${r}").`);
    o[i] = l * 16 + h;
  }
  return o;
}
function zt(e, t) {
  const n = Jt(e, t);
  return xe(n);
}
function $e(e, t = {}) {
  const n = Mt.encode(e);
  return typeof t.size == "number" ? (G(n, { size: t.size }), z(n, { dir: "right", size: t.size })) : n;
}
function Wt(e, t) {
  return Ot(j(e, { strict: !1 }) ? kt(e) : e);
}
class Pt extends b {
  constructor({ address: t }) {
    super(`Address "${t}" is invalid.`, {
      metaMessages: [
        "- Address must be a hex value of 20 bytes (40 hex characters).",
        "- Address must match its checksum counterpart."
      ],
      name: "InvalidAddressError"
    });
  }
}
class _e extends Map {
  constructor(t) {
    super(), Object.defineProperty(this, "maxSize", {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: void 0
    }), this.maxSize = t;
  }
  get(t) {
    const n = super.get(t);
    return super.has(t) && n !== void 0 && (this.delete(t), super.set(t, n)), n;
  }
  set(t, n) {
    if (super.set(t, n), this.maxSize && this.size > this.maxSize) {
      const r = this.keys().next().value;
      r && this.delete(r);
    }
    return this;
  }
}
const F = /* @__PURE__ */ new _e(8192);
function Re(e, t) {
  if (F.has(`${e}.${t}`))
    return F.get(`${e}.${t}`);
  const n = e.substring(2).toLowerCase(), r = Wt($e(n)), s = n.split("");
  for (let i = 0; i < 40; i += 2)
    r[i >> 1] >> 4 >= 8 && s[i] && (s[i] = s[i].toUpperCase()), (r[i >> 1] & 15) >= 8 && s[i + 1] && (s[i + 1] = s[i + 1].toUpperCase());
  const o = `0x${s.join("")}`;
  return F.set(`${e}.${t}`, o), o;
}
function Dt(e, t) {
  if (!Bt(e, { strict: !1 }))
    throw new Pt({ address: e });
  return Re(e, t);
}
const Ft = /^0x[a-fA-F0-9]{40}$/, B = /* @__PURE__ */ new _e(8192);
function Bt(e, t) {
  const { strict: n = !0 } = t ?? {}, r = `${e}.${n}`;
  if (B.has(r))
    return B.get(r);
  const s = Ft.test(e) ? e.toLowerCase() === e ? !0 : n ? Re(e) === e : !0 : !1;
  return B.set(r, s), s;
}
class x extends b {
  constructor(t) {
    const { docsPath: n, field: r, metaMessages: s } = t;
    super(`Invalid Sign-In with Ethereum message field "${r}".`, {
      docsPath: n,
      metaMessages: s,
      name: "SiweInvalidMessageFieldError"
    });
  }
}
function me(e) {
  if (/[^a-z0-9\:\/\?\#\[\]\@\!\$\&\'\(\)\*\+\,\;\=\.\-\_\~\%]/i.test(e) || /%[^0-9a-f]/i.test(e) || /%[0-9a-f](:?[^0-9a-f]|$)/i.test(e))
    return !1;
  const t = Vt(e), n = t[1], r = t[2], s = t[3], o = t[4], i = t[5];
  if (!(n != null && n.length && s.length >= 0))
    return !1;
  if (r != null && r.length) {
    if (!(s.length === 0 || /^\//.test(s)))
      return !1;
  } else if (/^\/\//.test(s))
    return !1;
  if (!/^[a-z][a-z0-9\+\-\.]*$/.test(n.toLowerCase()))
    return !1;
  let c = "";
  return c += `${n}:`, r != null && r.length && (c += `//${r}`), c += s, o != null && o.length && (c += `?${o}`), i != null && i.length && (c += `#${i}`), c;
}
function Vt(e) {
  return e.match(/(?:([^:\/?#]+):)?(?:\/\/([^\/?#]*))?([^?#]*)(?:\?([^#]*))?(?:#(.*))?/);
}
function Kt(e) {
  const { chainId: t, domain: n, expirationTime: r, issuedAt: s = /* @__PURE__ */ new Date(), nonce: o, notBefore: i, requestId: c, resources: l, scheme: h, uri: g, version: A } = e;
  {
    if (t !== Math.floor(t))
      throw new x({
        field: "chainId",
        metaMessages: [
          "- Chain ID must be a EIP-155 chain ID.",
          "- See https://eips.ethereum.org/EIPS/eip-155",
          "",
          `Provided value: ${t}`
        ]
      });
    if (!(qt.test(n) || Ht.test(n) || jt.test(n)))
      throw new x({
        field: "domain",
        metaMessages: [
          "- Domain must be an RFC 3986 authority.",
          "- See https://www.rfc-editor.org/rfc/rfc3986",
          "",
          `Provided value: ${n}`
        ]
      });
    if (!Gt.test(o))
      throw new x({
        field: "nonce",
        metaMessages: [
          "- Nonce must be at least 8 characters.",
          "- Nonce must be alphanumeric.",
          "",
          `Provided value: ${o}`
        ]
      });
    if (!me(g))
      throw new x({
        field: "uri",
        metaMessages: [
          "- URI must be a RFC 3986 URI referring to the resource that is the subject of the signing.",
          "- See https://www.rfc-editor.org/rfc/rfc3986",
          "",
          `Provided value: ${g}`
        ]
      });
    if (A !== "1")
      throw new x({
        field: "version",
        metaMessages: [
          "- Version must be '1'.",
          "",
          `Provided value: ${A}`
        ]
      });
    if (h && !Xt.test(h))
      throw new x({
        field: "scheme",
        metaMessages: [
          "- Scheme must be an RFC 3986 URI scheme.",
          "- See https://www.rfc-editor.org/rfc/rfc3986#section-3.1",
          "",
          `Provided value: ${h}`
        ]
      });
    const w = e.statement;
    if (w != null && w.includes(`
`))
      throw new x({
        field: "statement",
        metaMessages: [
          "- Statement must not include '\\n'.",
          "",
          `Provided value: ${w}`
        ]
      });
  }
  const S = Dt(e.address), f = h ? `${h}://${n}` : n, U = e.statement ? `${e.statement}
` : "", k = `${f} wants you to sign in with your Ethereum account:
${S}

${U}`;
  let E = `URI: ${g}
Version: ${A}
Chain ID: ${t}
Nonce: ${o}
Issued At: ${s.toISOString()}`;
  if (r && (E += `
Expiration Time: ${r.toISOString()}`), i && (E += `
Not Before: ${i.toISOString()}`), c && (E += `
Request ID: ${c}`), l) {
    let w = `
Resources:`;
    for (const m of l) {
      if (!me(m))
        throw new x({
          field: "resources",
          metaMessages: [
            "- Every resource must be a RFC 3986 URI.",
            "- See https://www.rfc-editor.org/rfc/rfc3986",
            "",
            `Provided value: ${m}`
          ]
        });
      w += `
- ${m}`;
    }
    E += w;
  }
  return `${k}
${E}`;
}
const qt = /^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,}(:[0-9]{1,5})?$/, Ht = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(:[0-9]{1,5})?$/, jt = /^localhost(:[0-9]{1,5})?$/, Gt = /^[a-zA-Z0-9]{8,}$/, Xt = /^([a-zA-Z][a-zA-Z0-9+-.]*)$/, Zt = (e, t, n, r) => {
  const s = window.location.host, o = window.location.origin, i = new Date(Date.now() + 10 * 60 * 1e3);
  return Kt({
    domain: s,
    address: e,
    statement: r ?? "Sign In to Kleros with Ethereum.",
    uri: o,
    version: "1",
    chainId: n,
    nonce: t,
    expirationTime: i
  });
}, Yt = _`
  mutation AddUser($settings: AddUserSettingsDto!) {
    addUser(addUserSettings: $settings)
  }
`;
async function Qt(e, t) {
  const n = {
    settings: t
  };
  return e.request(Yt, n).then(async (r) => r.addUser).catch((r) => {
    var o, i;
    console.log("Add User error:", { errors: r });
    const s = (i = (o = r == null ? void 0 : r.response) == null ? void 0 : o.errors) == null ? void 0 : i[0];
    throw s ? new K(s == null ? void 0 : s.message, { ...s }) : new Error("Unknown Error");
  });
}
const en = _`
  query GetUser {
    user {
      email
      isEmailVerified
      emailUpdateableAt
    }
  }
`;
async function tn(e) {
  return e.request(en).then((t) => t.user).catch((t) => {
    var r, s;
    console.log("Error fetching user :", { errors: t });
    const n = Array.isArray((r = t == null ? void 0 : t.response) == null ? void 0 : r.errors) ? (s = t.response.errors[0]) == null ? void 0 : s.message : "Error fetching user";
    throw Error(n);
  });
}
const nn = _`
  mutation UpdateEmail($newEmail: String!) {
    updateEmail(newEmail: $newEmail)
  }
`;
async function rn(e, t) {
  const n = t;
  return e.request(nn, n).then(async (r) => r.updateEmail).catch((r) => {
    var o, i;
    console.log("Update Email error:", { errors: r });
    const s = (i = (o = r == null ? void 0 : r.response) == null ? void 0 : o.errors) == null ? void 0 : i[0];
    throw s ? new K(s == null ? void 0 : s.message, { ...s }) : new Error("Unknown Error");
  });
}
const sn = _`
  mutation ConfirmEmail($address: Address!, $token: String!) {
    confirmEmail(confirmEmailInput: { address: $address, token: $token }) {
      isConfirmed
      isTokenExpired
      isTokenInvalid
    }
  }
`;
async function on(e, t) {
  const n = t;
  return e.request(sn, n).then(async (r) => r.confirmEmail).catch((r) => {
    throw console.log("Confirm Email error:", { errors: r }), new Error("Unable to verify.");
  });
}
async function cn(e, t) {
  const n = new FormData();
  return n.append("file", t.file, t.name), n.append("name", t.name), n.append("product", t.product), n.append("role", t.role), fetch(`${e.baseUrl}/ipfs/file`, {
    method: "POST",
    headers: {
      authorization: `Bearer ${e.authToken}`
    },
    body: n
  }).then(async (r) => {
    if (!r.ok) {
      const s = await r.json().catch(() => ({ message: "Error uploading to IPFS" }));
      throw r.status === 401 ? new Te(s.message) : new Error(s.message);
    }
    return await r.text();
  });
}
class Te extends Error {
  constructor(t) {
    super(t), this.name = "AuthorizationError", Error.captureStackTrace && Error.captureStackTrace(this, this.constructor);
  }
}
var an = /* @__PURE__ */ ((e) => (e.CourtV1 = "CourtV1", e.CourtV2 = "CourtV2", e.Curate = "Curate", e.Escrow = "Escrow", e.Governor = "Governor", e.ProofOfHumanity = "ProofOfHumanity", e.Reality = "Reality", e.Test = "Test", e))(an || {}), Oe = /* @__PURE__ */ ((e) => (e.Evidence = "evidence", e.Generic = "generic", e.IdentificationVideo = "identification-video", e.CurateItemImage = "curate-item-image", e.CurateItemFile = "curate-item-file", e.Logo = "logo", e.MetaEvidence = "meta-evidence", e.Photo = "photo", e.Policy = "policy", e.Test = "test", e))(Oe || {});
const V = (e) => typeof e > "u" || e === null;
function un(e, t) {
  const [n, r] = O(() => {
    try {
      const o = window.sessionStorage.getItem(e);
      return o ? JSON.parse(o) : t;
    } catch (o) {
      return console.log("useSessionStorage:", { err: o }), t;
    }
  });
  return [n, (o) => {
    try {
      window.sessionStorage.setItem(e, JSON.stringify(o));
    } finally {
      r(o);
    }
  }];
}
const ln = _`
  query Roles($product: Products!) {
    roles(product: $product) {
      name
      restriction {
        maxSize
        allowedMimeTypes
      }
    }
  }
`;
async function fn(e, t) {
  return e.request(ln, { product: t }).then((n) => n.roles).catch((n) => {
    var s, o;
    console.log("Error fetching roles :", { errors: n });
    const r = Array.isArray((s = n == null ? void 0 : n.response) == null ? void 0 : s.errors) ? (o = n.response.errors[0]) == null ? void 0 : o.message : "Error fetching roles";
    throw Error(r);
  });
}
const Ue = Le(void 0), wn = ({ children: e, config: t }) => {
  const { address: n } = ke({ config: t.wagmiConfig }), r = Ne({ config: t.wagmiConfig }), s = Je(), [o, i] = un("authToken", void 0), [c, l] = O(!1), [h, g] = O(!1), [A, S] = O(!1), [f, U] = O(!1), [k, E] = O(!1), { signMessageAsync: w } = ze({ config: t.wagmiConfig }), m = P(() => {
    const u = o ? {
      authorization: `Bearer ${o}`
    } : void 0;
    return new Me(`${t.uri}/graphql`, { headers: u });
  }, [o, t.uri]), X = T(() => {
    var u;
    try {
      if (!o || !n) return !1;
      const a = oe(o);
      return !(((u = a == null ? void 0 : a.sub) == null ? void 0 : u.toLowerCase()) !== n.toLowerCase() || a.exp && a.exp < Date.now() / 1e3);
    } catch {
      return !1;
    }
  }, [o, n]);
  D(() => {
    let u;
    const a = () => {
      const d = X();
      if (U(d), d && o)
        try {
          const C = oe(o).exp * 1e3 - Date.now();
          u = setTimeout(a, Math.max(0, C));
        } catch (y) {
          console.error("Error decoding JWT:", y), U(!1);
        }
    };
    return a(), () => {
      clearTimeout(u);
    };
  }, [o, X, n]);
  const {
    data: v,
    isLoading: Z,
    refetch: R
  } = se(
    {
      queryKey: ["UserSettings"],
      enabled: f && !V(n),
      queryFn: async () => {
        try {
          return !f || V(n) ? void 0 : await tn(m);
        } catch {
          return;
        }
      }
    },
    s
  ), { data: L } = se(
    {
      queryKey: ["RoleRestrictions"],
      enabled: !!t.product,
      staleTime: 1 / 0,
      queryFn: async () => {
        try {
          return await fn(m, t.product);
        } catch {
          return;
        }
      }
    },
    s
  );
  D(() => {
    f && R();
  }, [f, R]), D(() => {
    s.removeQueries({ queryKey: ["UserSettings"] });
  }, [n, s]);
  const Y = P(() => v ? !V(v.email) : !1, [v]);
  async function W(u) {
    var a;
    try {
      return await u();
    } catch (d) {
      throw (d instanceof Te || d instanceof K && ((a = d == null ? void 0 : d.extensions) == null ? void 0 : a.code) === "UNAUTHENTICATED") && U(!1), d;
    }
  }
  const Q = T(
    async (u) => {
      try {
        if (!n || !r) return;
        l(!0);
        const a = await it(m, n), d = Zt(n, a, r, u), y = await w({ message: d }), C = await st(m, { message: d, signature: y });
        i(C);
      } catch (a) {
        throw a;
      } finally {
        l(!1);
      }
    },
    [n, r, i, w, m]
  ), ee = T(
    async (u) => {
      try {
        if (!n || !f) return !1;
        g(!0);
        const a = await W(() => Qt(m, u));
        return R(), a;
      } catch (a) {
        throw a;
      } finally {
        g(!1);
      }
    },
    [n, f, g, m, R]
  ), te = T(
    async (u) => {
      try {
        if (!n || !f) return !1;
        S(!0);
        const a = await W(() => rn(m, u));
        return R(), a;
      } catch (a) {
        throw a;
      } finally {
        S(!1);
      }
    },
    [n, f, S, m, R]
  ), ne = T(
    async (u, a) => {
      try {
        if (!n || !f || !t.uri || !o) return null;
        if (L) {
          const y = L.find((C) => Oe[C.name] === a);
          if (!y) throw new Error("Unsupported role.");
          if (!y.restriction.allowedMimeTypes.includes(u.type)) throw new Error("Unsupported file type.");
          if (u.size > y.restriction.maxSize)
            throw new Error(
              `File too big. Max allowed size : ${(y.restriction.maxSize / (1024 * 1024)).toFixed(2)} mb.`
            );
        }
        E(!0);
        const d = await W(
          () => cn({ baseUrl: t.uri, authToken: o }, { file: u, name: u.name, role: a, product: t.product })
        );
        return d ? `/ipfs/${d}` : null;
      } catch (d) {
        throw d;
      } finally {
        E(!1);
      }
    },
    [n, f, E, o, t.uri, t.product, L]
  ), re = T(
    async (u) => {
      try {
        return S(!0), { ...await on(m, u), isError: !1 };
      } catch (a) {
        return console.log("Confirm Email Error : ", a == null ? void 0 : a.message), { isConfirmed: !1, isTokenExpired: !1, isTokenInvalid: !1, isError: !0 };
      }
    },
    [m]
  );
  return /* @__PURE__ */ ve.createElement(
    Ue.Provider,
    {
      value: P(
        () => ({
          isVerified: f,
          isSigningIn: c,
          isAddingUser: h,
          authoriseUser: Q,
          addUser: ee,
          user: v,
          isFetchingUser: Z,
          updateEmail: te,
          isUpdatingUser: A,
          userExists: Y,
          isUploadingFile: k,
          uploadFile: ne,
          confirmEmail: re,
          roleRestrictions: L
        }),
        [
          f,
          c,
          h,
          Q,
          ee,
          v,
          Z,
          te,
          A,
          Y,
          k,
          ne,
          re,
          L
        ]
      )
    },
    e
  );
}, En = () => {
  const e = Ce(Ue);
  if (!e)
    throw new Error("Context Provider not found.");
  return e;
};
export {
  wn as AtlasProvider,
  Te as AuthorizationError,
  an as Products,
  Oe as Roles,
  Qt as addUser,
  on as confirmEmail,
  Zt as createMessage,
  tn as fetchUser,
  it as getNonce,
  st as loginUser,
  rn as updateEmail,
  cn as uploadToIpfs,
  En as useAtlasProvider
};
//# sourceMappingURL=kleros-app.js.map
